unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  GsFinancialScroller, ExtCtrls, StdCtrls, GsScroller, ExtDlgs, Spin,
  ComCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Button1: TButton;
    Button2: TButton;
    Bevel1: TBevel;
    Panel1: TPanel;
    Bevel2: TBevel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Image1: TImage;
    Label5: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Button3: TButton;
    Button4: TButton;
    CheckBox1: TCheckBox;
    Panel2: TPanel;
    ColorDialog1: TColorDialog;
    FontDialog1: TFontDialog;
    OpenPictureDialog1: TOpenPictureDialog;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    TrackBar1: TTrackBar;
    Label6: TLabel;
    Label7: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure CheckBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  
implementation

uses Unit2;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Left := 10;
  Top := 10;
end;

procedure TForm1.FormShow(Sender: TObject);
var
  I: Integer;
  S: string;
begin
  for I := 0 to pred(Form2.GsScroller1.Items.Count) do
  begin
    S := 'TScrollerItem' + IntToStr(I + 1) + ' - (' +
      Form2.GsScroller1.Items[I].Text1 + ' ' + Form2.GsScroller1.Items[I].Text2 + ')';
    ListBox1.Items.Add(S);
  end;
  ListBox1.ItemIndex := 0;
  ListBox1Click(nil);
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var
  I: Integer;
  ScrollerItem: TScrollerItem;
begin
  I := ListBox1.ItemIndex;
  if (I > -1) and (I <= pred(Form2.GsScroller1.Items.Count)) then
  begin
    Panel1.Visible := True;
    ScrollerItem := Form2.GsScroller1.Items[I];
    Edit1.Text := ScrollerItem.Text1;
    Edit2.Text := ScrollerItem.Text2;
    Edit3.Text := ScrollerItem.Hyperlink;
    SpinEdit1.Value := ScrollerItem.Margin;
    CheckBox1.Checked := not ScrollerItem.UseTextImage;
    Panel2.Color := ScrollerItem.Background;
    Image1.Picture.Assign(ScrollerItem.GetFace);
  end else
    Panel1.Visible := False;
end;

procedure TForm1.CheckBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  I: Integer;
  ScrollerItem: TScrollerItem;
  B: TBitmap;
begin
  if Button <> mbLeft then Exit;
  I := ListBox1.ItemIndex;
  if (I > -1) and (I <= pred(Form2.GsScroller1.Items.Count)) then
  begin
    ScrollerItem := Form2.GsScroller1.Items[I];
    if CheckBox1.Checked then
    begin
      if OpenPictureDialog1.Execute then
      begin
        B := TBitmap.Create;
        B.LoadFromFile(OpenPictureDialog1.FileName);
        if B.Height > Form2.GsScroller1.Height then
        begin
          ShowMessage('The bitmap height must be under 33 pixels!');
          B.Free;
          Exit;
        end;
        ScrollerItem.Bitmap.Assign(B);
        B.Free;
        ScrollerItem.UseTextImage := False;
        Image1.Picture.Assign(ScrollerItem.GetFace);        
        CheckBox1.Checked := True;
      end else
        CheckBox1.Checked := False;
    end else
      if not ScrollerItem.Bitmap.Empty then
      begin
        ScrollerItem.Bitmap.FreeImage;
        ScrollerItem.UseTextImage := True;
        Image1.Picture.Assign(ScrollerItem.GetFace);        
        CheckBox1.Checked := False;
      end;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  I: Integer;
  ScrollerItem: TScrollerItem;
begin
  I := ListBox1.ItemIndex;
  if (I > -1) and (I <= pred(Form2.GsScroller1.Items.Count)) then
  begin
    ScrollerItem := Form2.GsScroller1.Items[I];
    FontDialog1.Font.Assign(ScrollerItem.Font);
    if FontDialog1.Execute then
    begin
      ScrollerItem.Font.Assign(FontDialog1.Font);
      ScrollerItem.Repaint;
      Image1.Picture.Assign(ScrollerItem.GetFace);      
    end;
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  I: Integer;
  ScrollerItem: TScrollerItem;
begin
  I := ListBox1.ItemIndex;
  if (I > -1) and (I <= pred(Form2.GsScroller1.Items.Count)) then
  begin
    ScrollerItem := Form2.GsScroller1.Items[I];
    ColorDialog1.Color := ScrollerItem.Background;
    if ColorDialog1.Execute then
    begin
      ScrollerItem.Background := ColorDialog1.Color;
      Panel2.Color := ColorDialog1.Color;
      ScrollerItem.Repaint;
      Image1.Picture.Assign(ScrollerItem.GetFace);
    end;
  end;
end;

procedure TForm1.Edit1Change(Sender: TObject);
var
  I: Integer;
  ScrollerItem: TScrollerItem;
begin
  I := ListBox1.ItemIndex;
  if (I > -1) and (I <= pred(Form2.GsScroller1.Items.Count)) then
  begin
    ScrollerItem := Form2.GsScroller1.Items[I];
    ScrollerItem.Text1 := Edit1.Text;
    ScrollerItem.Text2 := Edit2.Text;
    ScrollerItem.Hyperlink := Edit3.Text;
    ScrollerItem.Margin := SpinEdit1.Value;
    ScrollerItem.Repaint;
    ListBox1.Items[I] := 'TScrollerItem' + IntToStr(I + 1)  + ' - (' +
      ScrollerItem.Text1 + ' ' + ScrollerItem.Text2 + ')';
    Image1.Picture.Assign(ScrollerItem.GetFace);
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  I: Integer;
begin
  I := ListBox1.ItemIndex;
  if (I > -1) and (I <= pred(Form2.GsScroller1.Items.Count)) then
  Form2.GsScroller1.Items.Delete(I);
  ListBox1.ItemIndex := -1;
  Panel1.Visible := False;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  I: Integer;
  ScrollerItem: TScrollerItem;
begin
  ScrollerItem := Form2.GsScroller1.Items.Add;
  I := ListBox1.Items.Add('TScrollerItem' + IntToStr(I + 1)  + ' - (' +
    ScrollerItem.Text1 + ' ' + ScrollerItem.Text2 + ')');
  ListBox1.ItemIndex := I;
  ListBox1Click(nil);
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  case TrackBar1.Position of
    1: begin
      Form2.GsScroller1.Direction := sdRightLeft;
      Form2.GsScroller1.ScrollSpeed := speed5_VeryFast;
    end;
    2: begin
      Form2.GsScroller1.Direction := sdRightLeft;
      Form2.GsScroller1.ScrollSpeed := speed4_Fast;
    end;
    3: begin
      Form2.GsScroller1.Direction := sdRightLeft;
      Form2.GsScroller1.ScrollSpeed := speed3_Normal;
    end;
    4: begin
      Form2.GsScroller1.Direction := sdRightLeft;
      Form2.GsScroller1.ScrollSpeed := speed2_Slow;
    end;
    5: begin
      Form2.GsScroller1.Direction := sdRightLeft;
      Form2.GsScroller1.ScrollSpeed := speed1_VerySlow;
    end;
    6: begin
      Form2.GsScroller1.Direction := sdLeftRight;
      Form2.GsScroller1.ScrollSpeed := speed1_VerySlow;
    end;
    7: begin
      Form2.GsScroller1.Direction := sdLeftRight;
      Form2.GsScroller1.ScrollSpeed := speed2_Slow;
    end;
    8: begin
      Form2.GsScroller1.Direction := sdLeftRight;
      Form2.GsScroller1.ScrollSpeed := speed3_Normal;
    end;
    9: begin
      Form2.GsScroller1.Direction := sdLeftRight;
      Form2.GsScroller1.ScrollSpeed := speed4_Fast;
    end;
    10: begin
      Form2.GsScroller1.Direction := sdLeftRight;
      Form2.GsScroller1.ScrollSpeed := speed5_VeryFast;
    end;
  end;
end;

end.
